package com.example.demo.Dto;

import java.text.DateFormat;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.time.format.DateTimeFormatter;
import java.util.Date;
import java.util.Locale;

import com.fasterxml.jackson.annotation.JsonCreator;
import com.fasterxml.jackson.annotation.JsonProperty;

public class UserDTO {
    private String name;
    private String password;
    private Date dateCreate;

    private final SimpleDateFormat formatter = new SimpleDateFormat("dd.MM.yy");
    public UserDTO() {

    }

    @JsonCreator
    public UserDTO(
            @JsonProperty(value = "name") String name,
            @JsonProperty(value = "dateCreate") String dateCreate,
            @JsonProperty(value = "password") String password
            ) throws ParseException {
        this.name = name;
        this.dateCreate = formatter.parse(dateCreate);
        this.password = password;
    }

    public String getName() {
        return name;
    }

    public String getDateCreate() {
        return formatter.format(dateCreate);
    }

    public String getPassword() {
        return password;
    }
}
